;;Obsolete parts of filebuf


;;;_ , Virtual directory
;;Deprecated

;;;_  . Structures

(defstruct 
   (emtb:virtual-dir
      (:constructor make-emtb:virtual-dir
	 (root 
	    &key 
	    dir file-basenames mutable
	    &aux 
	    (dir-2 (expand-file-name dir root))
	    (abs-dir
	       (if
		  mutable
		  (progn
		     (assert (not (file-name-absolute-p dir)))
		     (assert (not
				(equal
				   root
				   emtb:slave-root)))
		     (expand-file-name dir emtb:slave-root))
		  dir-2))
	    (abs-master-dir
	       (if
		  mutable
		  dir-2
		  nil)))
	 ))
   
   
   "Example files"
   abs-dir
   abs-master-dir
   file-basenames)

;;;_   , Tests (of the ctor)

(rtest:deftest make-emtb:virtual-dir

   ;;Lest master and slave be the same filename:

   ("Disallow an absolute DIR argument"
      (rtest:gives-error
	 (make-emtb:virtual-dir 
	    emtb:virtual-dir:th:example-root
	    :mutable t 
	    :dir "/foo")))
   
   ("Disallow root = emtb:slave-root."
      (rtest:gives-error
	 (make-emtb:virtual-dir 
	    emtb:slave-root 
	    :mutable t 
	    :dir ".")))

   ;;YAGNI: Avoid collision between the same name in different
   ;;projects, but that's unlikely to occur within the same test,
   ;;which is the only time it would matter.

   )


;;;_  . Interactive help creating it

(require 'handhold)


;;;_   , Test data

(rtest:if-avail
   (defconst emtb:virtual-dir:ctor-arglist
      '(emtb:virtual-dir:th:example-root
	  :dir
	  "bar" 
	  :file-basenames
	  '("1.txt" "2.txt"))
      "An example arglist to `make-emtb:virtual-dir'")

   (defconst emtb:virtual-dir:ctor-widget-value
      '(emtb:virtual-dir:th:example-root
	  "bar" 
	  ;;"" ;;For now, master-dir still exists as a string.
	  ("1.txt" "2.txt"))
      "An example widget-value corresponding to
`emtb:virtual-dir:ctor-arglist'"))

;;;_   , make-emtb:virtual-dir:sexp->widget-value

;;This could be derived from the ctor definition and the widget
;;definition.


;;Check-type only seems to accept symbols, not lists, so we spread the
;;type check of file-basenames over several calls.
(defun* make-emtb:virtual-dir:sexp->widget-value 
   (root &key dir 
      ;;master-dir 
      file-basenames)
   ""
   (check-type root symbol)
   (check-type dir string)
   ;;master-dir is deprecated.
   (check-type file-basenames cons)
   (check-type (first file-basenames) (member quote))
   (check-type (second file-basenames) list)
   (list root dir 
      ;;"this-is-deprecated" 
      (eval file-basenames)))

;;;_    . Tests
;;Fails.
(rtest:deftest make-emtb:virtual-dir:sexp->widget-value
   
   (  "Situation: Normal.  
ROOT is a symbol.
DIR is a string.
FILE-BASENAMES is a quoted list. 
Response: Accepts it."
      (not
	 (rtest:gives-error
	    (make-emtb:virtual-dir:sexp->widget-value
	       'emtb:virtual-dir:th:example-root
	       :dir 
	       '"bar" 
	       :file-basenames
	       ''("1.txt" "2.txt")))))

   ("Accepts the example"
      (not
	 (rtest:gives-error
	    (apply #'make-emtb:virtual-dir:sexp->widget-value
	       emtb:virtual-dir:ctor-arglist))))

   ;;We'd like to test that it transforms into
   ;;`emtb:virtual-dir:ctor-widget-value', but as long as we're
   ;;still handling master-dir, it won't (won't fairly, anyways).
   
   (
      "Situation: Root is not a symbol"
      (rtest:gives-error
	 (make-emtb:virtual-dir:sexp->widget-value
	    emtb:virtual-dir:th:example-root
	    :dir 
	    '"bar" 
	    :file-basenames
	    ''("1.txt" "2.txt"))))
   
   
   (  "Situation: Dir is not a string"
      (rtest:gives-error
	 (make-emtb:virtual-dir:sexp->widget-value
	    'emtb:virtual-dir:th:example-root
	    :dir 
	    'emtb:virtual-dir:th:example-root
	    :file-basenames
	    ''("1.txt" "2.txt"))))
   
   ("Situation: File basenames is not a quoted list"
      (rtest:gives-error
	 (make-emtb:virtual-dir:sexp->widget-value
	    'emtb:virtual-dir:th:example-root
	    :dir 
	    '"bar" 
	    :file-basenames
	    'emtb:virtual-dir:th:example-root)))
   )

;;;_   , make-emtb:virtual-dir:widget-value->sexp

;;This could be trivially derived from the ctor definition and the
;;widget definition.
(defun make-emtb:virtual-dir:widget-value->sexp
   (root dir file-basenames) 
   ""
   `(make-emtb:virtual-dir
       ,root
       ,@(if dir
	    (list ':dir dir))
;;        ,@(if master-dir
;; 	    (list ':master-dir master-dir))
       ,@(if file-basenames
	    (list ':file-basenames `'(,@file-basenames)))))

;;;_    . Tests
;;Fails
(rtest:deftest make-emtb:virtual-dir:widget-value->sexp

   ;;This can't just be tested by simple comparison, because the forms
   ;;might mean the same but differ in particulars.  Instead we
   ;;compare values that have both been transformed - any particulars
   ;;ought to "fall the same way" both times.
   ("Shows: `make-emtb:virtual-dir:widget-value->sexp' reverses
`make-emtb:virtual-dir:sexp->widget-value'.  Both are to be applied
to forms."

      (let 
	 ((wid-value
	     (apply
		#'make-emtb:virtual-dir:sexp->widget-value
		emtb:virtual-dir:ctor-arglist)))
	 (equal
	    wid-value
	    (apply
	       #'make-emtb:virtual-dir:sexp->widget-value
	       (cdr
		  (apply 
		     #'make-emtb:virtual-dir:widget-value->sexp
		     wid-value)))))))

;;;_   , emtb:virtual-dir:widget-type


(defconst emtb:virtual-dir:widget-type
   '(list
       :tag "Ctor call to make a virtual directory"
       ;;A symbol that refers to a string.  
       (symbol :tag "Root directory symbol"
	  :match 
	  (lambda (widget value)
	     (and
		(symbolp value)
		(if (boundp value)
		   (stringp (symbol-value value)))))
 	  :complete-function
 	  (lambda ()
 	     (interactive)
 	     (lisp-complete-symbol
		#'(lambda (x)
		     (if (boundp x)
			(stringp (symbol-value x)))))))
       
       (directory :tag "Directory relative to project root"
	  :complete-function
	  (lambda ()
	     (interactive)
	     (let*
		(  (widget
		      (widget-field-find (point)))
		   (directory 
		      (symbol-value 
			 (car 
			    (tehom-widget-nth-parent-value 1)))))
		(tehom-widget-filename-complete widget directory))))

       (repeat 
	  :tag "List of relative file names" 
	  (file
	     :complete-function
	     (lambda ()
		(interactive)
		(let*
		   (  (widget
			 (widget-field-find (point)))
		      (value
			 (tehom-widget-nth-parent-value 2)))
		   
		   (tehom-widget-filename-complete 
		      widget 
		      (expand-file-name
			 (second value)
			 (symbol-value (car value)))))))))
   "" )
;;;_    @ decisions/7 Describing these objects easier 
;;;_    . Tests

;;Tested thru handhold (And only informally tested even there)

;;;_   , `make-emtb:virtual-dir' properties

;;Format is alpha, might change drastically.
(put 'make-emtb:virtual-dir 'handhold:data
   (list
      emtb:virtual-dir:widget-type
      #'make-emtb:virtual-dir:widget-value->sexp
      #'make-emtb:virtual-dir:sexp->widget-value))

;;;_  . Test setup

(defconst emtb:virtual-dir:th:example-root 
   emtb:th-examples-dir
   "Dummy symbol referring to the root directory of a dummy project" )
'  ;;Obsolete.
(defmacro emtb:virtual-dir:th:usuals-x (&rest body)
   ""
   
   `(symbol-macrolet
       (
	  (filesthing-list 
	     emtb:virtual-dir:thd:example-multi)
	  )
       ,@body))

;;;_  . Example objects

(defconst emtb:virtual-dir:thd:example-simple
   (make-emtb:virtual-dir
      emtb:virtual-dir:th:example-root
      :dir "bar" 
      :file-basenames
      '("1.txt" "2.txt"))
   "Example virtual directory, simple case" )

(defconst emtb:virtual-dir:thd:example-slaved
   (make-emtb:virtual-dir
      emtb:th-examples-dir
      :dir "bar"
      :mutable t
      :file-basenames
      '("3.txt"))
   "Example slaved files" )

(defconst emtb:virtual-dir:thd:example-multi
   (list
      emtb:virtual-dir:thd:example-simple
      emtb:virtual-dir:thd:example-slaved
      (make-emtb:virtual-dir
	 emtb:virtual-dir:th:example-root
	 :mutable t
	 :dir "bar/single-master/"
	 :file-basenames
	 '("alone.txt")))

   
   "Example virtual directory" )

;;;_  . emtb:virtual-dir:get-match

(defun emtb:virtual-dir:get-match (basename filesthing-list)
   ""
   (unless (listp filesthing-list)
      (if
	 (emtb:virtual-dir-p filesthing-list)
	 (error "Arg Filesthing-List should be a list of filesthing,
not a single filesthing..")
	 (error "Arg filesthing-list is not a list")))
   
   (find basename filesthing-list 
      :test 
      #'(lambda (key el)
	   (member key 
	      (emtb:virtual-dir-file-basenames el)))))

;;;_   , Tests

(rtest:deftest emtb:virtual-dir:get-match

   ("Situation: name is one of the names in first object.  
Response: Return first object"
      (equal
	 (emtb:virtual-dir:get-match 
	    "1.txt" 
	    emtb:virtual-dir:thd:example-multi)
	 emtb:virtual-dir:thd:example-simple))
   
   ("Situation: name is one of the names in second object.  
Response: Return second object"

      (equal
	 (emtb:virtual-dir:get-match 
	    "3.txt" 
	    emtb:virtual-dir:thd:example-multi)
	 emtb:virtual-dir:thd:example-slaved))

   ("Situation: name is not one of the names.  
Response: Return nil"
      (not
	 (emtb:virtual-dir:get-match 
	    "nomatch.txt" 
	    emtb:virtual-dir:thd:example-multi))))


;;;_  . emtb:virtual-dir:suspected-list->singleton
(defun emtb:virtual-dir:suspected-list->singleton (basename maybe-list)
   ""
   
   (if
      (listp maybe-list)
      (emtb:virtual-dir:get-match basename maybe-list)
      maybe-list))

;;;_   , Tests

(put 'emtb:virtual-dir:suspected-list->singleton
   'rtest:test-thru
   'emtb:virtual-dir:base->filename)

;;Also thru emtb:virtual-dir:base->master-name 

;;;_  . -> true filenames

;;;_   , emtb:virtual-dir:base->filename

(defun emtb:virtual-dir:base->filename (basename filesthing)
   "Return the absolute filename corresponding to BASENAME.
FILESTHING is a filesthing"
   (expand-file-name 
      basename 
      (emtb:virtual-dir-abs-dir 
	 (emtb:virtual-dir:suspected-list->singleton 
	    basename 
	    filesthing))))

;;;_    . Tests

(rtest:deftest emtb:virtual-dir:base->filename

   ("Situation: Given basename is one of the basenames.
Response: Returns a filename expanded vs both root and dir"

      (equal
	 (emtb:virtual-dir:base->filename "1.txt"
	    emtb:virtual-dir:thd:example-simple)
	 (expand-file-name "1.txt"
	    (expand-file-name "bar" 
	       emtb:virtual-dir:th:example-root))))


   ;;YAGNI: Situation: Basename is not one of the basenames.

   )

;;;_   , emtb:virtual-dir:base->master-name

(defun emtb:virtual-dir:base->master-name (basename filesthing)
   ""
   
   (let
      ((master-dir (emtb:virtual-dir-abs-master-dir 
		      (emtb:virtual-dir:suspected-list->singleton
			 basename
			 filesthing))))
      (if
	 (null master-dir)
	 (error "Basename %s is not slaved" basename)
	 (expand-file-name basename master-dir))))


;;;_    . Tests
(rtest:deftest emtb:virtual-dir:base->master-name
   ("Situation: Given basename is one of the basenames and filesthing
is slaved.
Response: Returns a filename expanded vs both root and master dir"

      (equal
	 (emtb:virtual-dir:base->master-name "3.txt"
	    emtb:virtual-dir:thd:example-slaved)
	 (expand-file-name "3.txt"
	    (expand-file-name "bar" 
	       emtb:virtual-dir:th:example-root))))

   
   ;;YAGNI: Situation: filesthing is not slaved.
   
   )


;;;_  . Master/slave copying

;;;_   , Test data

(defconst emtb:thd:a-string 
   "Some text that won't match real file"
   "Example text for writing into files for tests" )

;;;_   , Test helper

(defmacro* emtb:th:let-slave-master-pair
   ((slave-name master-name basename virtual-dir) &rest body)
   "`let' the slave and master filenames around BODY.
If MASTER-NAME is nil, no master filename object is created"
   
   `(let
       (  
	  (,slave-name
	     (emtb:virtual-dir:base->filename 
		,basename
		,virtual-dir))
	  ,@(if master-name
	       `((,master-name
		    (emtb:virtual-dir:base->master-name
		       ,basename
		       ,virtual-dir)))
	       ()))
       ,@body))


;;;_   , emtb:fresh-copy

(defun emtb:fresh-copy (slave master)
   "Make a fresh copy from the master file"
   (make-directory (file-name-directory slave) t)
   (let 
      ((buf (get-file-buffer slave)))
      (when buf
	 ;;To avoid interaction.
	 (with-current-buffer buf
	    (set-buffer-modified-p nil))
	 (kill-buffer buf)))
   (copy-file master slave t))

;;;_    . Tests

;;Also tested thru emtb:virtual-dir:constantize.

(rtest:deftest emtb:fresh-copy
   ;;NOT AUTOMATABLE. The test here is that no user interaction
   ;;happens.  There is no simple way of checking that directly.
   ("Situation: Buffer already exists and has been modified.  
Response: Even so, there is no interaction.
IF THERE WAS USER INTERACTION, this test may have failed."

      (emtb:th:let-slave-master-pair
	 (file3-slave file3-master	 
	    "3.txt" 
	    emtb:virtual-dir:thd:example-slaved)

	 (with-current-buffer
	    (find-file-noselect file3-slave)
	    (insert emtb:thd:a-string))
	 (emtb:fresh-copy file3-slave file3-master)
	 t))

   ("Situation: slave-file doesn't exist and its parent directory
doesn't exist.
Response: Still opens without a problem"
      (emtb:th:let-slave-master-pair
	 (filename-slave filename-master 
	    "alone.txt"
	    emtb:virtual-dir:thd:example-multi)

	 ;;Delete that file if it exists.
	 (if (file-exists-p filename-slave)
	    (delete-file filename-slave))
	 
	 ;;Delete that directory if it exists (and if it seems safe)
	 (let
	    ((dir (file-name-directory filename-slave)))

	    (when (file-exists-p dir)
	       ;;Check that it contains no files now, other than ".."
	       ;;and "."
	       (unless
		  (= 
		     (length (directory-files dir nil "[^\.]+" t))
		     0)
		  (error "Other files are in directory so maybe we don't own it"))
	       (delete-directory dir)))

	 (not
	    (rtest:gives-error
	       (emtb:fresh-copy 
		  filename-slave
		  filename-master)))))

   )


;;;_   , emtb:virtual-dir:constantize

(defun emtb:virtual-dir:constantize (basename filesthing)
   ""
   (let
      ((filename
	  (emtb:virtual-dir:base->filename basename filesthing)))
      
      (if
	 ;;If there is a master dir...
	 (emtb:virtual-dir-abs-master-dir filesthing)
	 ;;Get a fresh copy.
	 (emtb:fresh-copy
	    filename
	    (emtb:virtual-dir:base->master-name basename
	       filesthing))
	 ;;Otherwise make buffer read-only.  Rationale: A test file
	 ;;shouldn't have other uses, and user can M-x
	 ;;toggle-read-only to modify it.
	 (let
	    ((buf (get-file-buffer filename)))
	    (when buf
	       (with-current-buffer buf
		  (setq buffer-read-only t)))))))

;;;_    . Tests

;;Also tested thru emtb:find-file-2

(rtest:deftest emtb:virtual-dir:constantize
   
   ("A slaved file is replaced by the master copy."
   
      (let
	 ((virtual-dir emtb:virtual-dir:thd:example-slaved))
	 (emtb:th:let-slave-master-pair
	    (slave master "3.txt" virtual-dir)
	    (with-temp-file slave
	       (insert emtb:thd:a-string))
	    (emtb:virtual-dir:constantize "3.txt" virtual-dir)
	    (emtb:files-match master slave))))

   
   ("A non-slaved file remains as it is."
      (let
	 ((virtual-dir emtb:virtual-dir:thd:example-simple))
	 (emtb:th:let-slave-master-pair
	    (file nil "1.txt" virtual-dir)
	    (with-temp-file file
	       (insert emtb:thd:a-string))
	    (emtb:virtual-dir:constantize "1.txt" virtual-dir)
	    (let
	       ((slave-str
		   (with-temp-buffer
		      (insert-file-contents file)
		      (buffer-string))))
	       (string-equal slave-str emtb:thd:a-string)))))

   ;;It's direct.
   '("Situation: Not slaved. buffer is not read-only.  Afterwards:
buffer is read-only."  
       
       )

   )

;;;_   , emtb:cautious-find-file

;;$$OBSOLETE
'
(defun emtb:cautious-find-file (filename)
   ""

   (unless
      (file-name-absolute-p filename)
      (error "Filename %s is not absolute" filename))

   (unless
      (file-exists-p filename)
      (error "File %s doesn't exist" filename))

   (find-file filename))


;;;_   , emtb:cautious-load-file

;;$$OBSOLETE
'
(defun emtb:cautious-load-file (filename visited-name)
   ""

   ;;`emtb:cautious-insert-file' will error if buffer is non-empty,
   ;;so we don't have to provide that.

   ;;Have to set VISITED arg so that within
   ;;`emtb:cautious-setup-file', `after-find-file' sees a filename
   ;;as it expects to.
   (emtb:cautious-insert-file filename t)
   (emtb:cautious-setup-file 
      visited-name 
      (file-name-directory filename)))


;;;_   , emtb:find-file-2

;;$$OBSOLETE Was used only by `emtb:make-form-find-file-2' and
;;`emtb:find-file-3', both obsolete.
;;$$ADAPT ME Change callers to call thru emtb:find-file-3.  Then
;;remove loc-string param and its related code.
(defun emtb:find-file-2 (filesthing-0 basename &optional loc-string)
   ""
	 
   (let*
      (
	 (filesthing 
	    (emtb:virtual-dir:suspected-list->singleton
	       basename
	       filesthing-0))

	 (filename
	    (emtb:virtual-dir:base->filename basename filesthing)))
      
      (emtb:virtual-dir:constantize basename filesthing)
      (emtb:find-file-goto-text filename loc-string)))

;;;_   , emtb:find-file-3

;;$$OBSOLETE Used only by old tests.
'
(defun* emtb:find-file-3 (context filebase &key at-str prepare-f) 
   "Find file FILEBASE, as expanded in filecontext CONTEXT.

If PREPARE-F is given, call it with no args.
If AT-STR is given, find it in the buffer and put point at the
beginning of it."
   
   (emtb:find-file-2 context filebase)
   (when prepare-f (funcall prepare-f))
   (if at-str 
      (emtb:goto-text at-str)
      (goto-char (point-min))))

;;;_  . emtb:make-form-find-file
;;$$OBSOLETE Used only by old tests.
'
(defun emtb:make-form-find-file-2 (options key context)
   "Return a form that interprets KEY in OPTIONS as an instruction to
switch to a buffer visiting a given file.  A second arg to KEY is
interpreted as a string to place point at, as in
`find-file-goto-text'.

OPTIONS and KEY can be symbols.  They are interpreted when the form is
evalled."

   (uti:form-by-option options key
      #'(lambda (x)
	   `(emtb:find-file-2
	       ,context
	       ,@(cdr x)))))

;;;_  . (Dep) emtb:w/context:buf-matches-file

;;Obsolescent
(defun emtb:w/context:buf-matches-file (context basename)
   "Return non-nil if buffer's contents are the same as contents of
the file BASENAME in context CONTEXT"
   
   (let*
      ((filename
	  (emtb:virtual-dir:base->filename basename context)))
      (string-equal 
	 (buffer-string) 
	 (emtb:file-contents filename))))
