;;;_ emtest/testhelp/mocks/keystuffer.el --- Keystuffer for testing (Part of Emtest)

;;;_. Headers
;;;_ , License
;; Copyright (C) 2010  Tom Breton (Tehom)

;; Author: Tom Breton (Tehom) <tehom@panix.com>
;; Keywords: lisp, maint

;; This file is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; This file is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs; see the file COPYING.  If not, write to
;; the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
;; Boston, MA 02111-1307, USA.

;;;_ , Commentary:

;; 


;;;_ , Requires

;;;_. Body

;;;_ , Proof of concept

'
(catch 'emt:keystuffer
   (let
      ((new-km ;;Encap building this
	  (make-sparse-keymap))
	 (keysym 'nonesuch))
      (set-keymap-parent new-km overriding-local-map)
      (define-key new-km (vector keysym) 
	 #'(lambda ()
	      (interactive)
	      (throw 'emt:keystuffer 144)))
      (let 
	 ((overriding-local-map new-km)
	   (unread-command-events (list keysym)))
	   ;;Correctly, this immediately aborts
	 (read-string "A string: "))))
;;;_ , keystuffer:events
;;No capture, takes event list to use

;;;_ , keystuffer:persist
;;Does the capture&persist part too

;;;_. Footers
;;;_ , Provides

(provide 'emtest/testhelp/mocks/keystuffer)

;;;_ * Local emacs vars.
;;;_  + Local variables:
;;;_  + mode: allout
;;;_  + End:

;;;_ , End
;;; emtest/testhelp/mocks/keystuffer.el ends here
